#!/usr/bin/perl
use warnings;
use strict;
use File::Basename;
use Net::IP;
use Net::DNS;

my $abusednsbl = "abuse-contacts.abusix.org";

if (@ARGV == 0) {
  print "usage: ", basename($0), " IP ...\n";
  exit 1;
}

my $res = Net::DNS::Resolver->new;

for my $host (@ARGV) {
  my $IP = $host;
  
  my $ip = new Net::IP ($IP);
  my $querystring = $ip->reverse_ip().$abusednsbl;
  $querystring =~ s/\.in-addr\.arpa//;
  my $query = $res->query($querystring, "txt");
  if ($query) {
    print (($query->answer)[0]->rdata, "\n");
  } else {
    print "no abuse address for $IP\n";
    exit 1;
  }
}
